--[[
	 2013 CloudSixteen.com do not share, re-distribute or modify
	without permission of its author (kurozael@gmail.com).
--]]

ITEM = Clockwork.item:New("book_base");
ITEM.name = "Vortigaunt Anatomy";
ITEM.cost = 10;
ITEM.model = "models/props_lab/bindergreenlabel.mdl";
ITEM.uniqueID = "book_va";
ITEM.business = true;
ITEM.description = "A green book with a Vortigaunt on the front.";
ITEM.bookInformation = [[
<font color='red' size='4'>Written by Jamie Ruzicano.</font>

Vortigaunts, affectionately known as Vorts by their allies, are sapient 
aliens. Their native home is the Xenian border world, from where they were 
enslaved and forced to lead an invasion of Earth following the Black Mesa 
Incident. Following the death of the latter, they have as a species chosen 
to ally themselves with the remaining humans on earth.

In appearance, a Vortigaunt is roughly humanoid with two legs and two 
arms, but has an additional arm protruding from it's chest. This extra 
limb is a feature also found in the other bipedal, sapient species from 
Xen. This similarity, along with other shared features such as red eyes 
and back-jointed legs, is strongly suggestive of a common ancestry with 
other intelligent Xenian lifeforms. Apparently, this third arm is used for
 feeding, as both Vortigaunts and Alien Grunts are often seen bending over
 slain victims while feeding off of it. Vortigaunts have a mottled green-
brown skin; similar to a reptile's, sharp teeth, and clawed hands. 
Vortigaunts have a slightly hunched posture, and their faces are dominated 
by a large, single red eye, surrounded by five smaller eyes. Closer 
inspection reveals that the smaller "eyes" are simply additional openings 
that lead to one gigantic eyeball. They also appear to have a belly 
button, suggesting Vortigaunts have live births.

Vortigaunts are very intelligent and social creatures, and often display 
these traits. Vortigaunts are often seen in pairs or groups, and are 
capable of developing intelligent strategies. When faced with a superior 
enemy, Vortigaunts will often run away from the scene, and if possible, 
will group together with others to form a stronger force. Vortigaunts 
possess their own method of vocal communication, which they can be heard 
using and referring to as "flux shifting". This method of communication 
involves both speakers vocalizing at the same time, which separates it 
from all known human languages. According to the Vortigaunts, flux 
shifting cannot be understood by "those whose Vortal inputs are impaired", 
which may suggest that other inaudible components are involved, perhaps 
explaining why it is incomprehensible to humans. Another explanation is 
that they are subtly suggesting - via the use of the word 'impaired' - 
that the senses of humans are not quite as 'advanced' as theirs.


Vortigaunts have learned to speak at least one human language, predictably
 English. The Vortigaunts' use of English is slightly strange, however, as 
they use archaic words and grammatical structures which are largely 
obsolete amongst present-day human speakers. It is not known whether this 
is a lack of understanding or a deliberate choice on their part.

Vortigaunts were once an enslaved species, used as factory workers and 
drone soldiers. Based on comments made by some of the more aged 
Vortigaunts, it seems that the species has endured slavery for many 
generations, and enforced servitude appears to have formed the bedrock of 
Vortigaunt history and culture. Vortigaunts have many traditions, 
including an apparent oral tradition of passing down poetry and songs from 
generation to generation. They believe in a binding life-force which they 
call the "Vortessence", which could be consitered a religion or a popular 
belief. Due to their use of this force, which remains untapped by the 
human species, the Vortigaunt species is capable of a form of telepathy, 
at least amongst their own kind. One particular comment made by a 
Vortigaunt - "We have lost all dear to us" - suggests that the Vortigaunts 
have lost their home world and civilization, yet are determined to start 
again alongside the human race on Earth. There also seems to be a 
possibility that Vortigaunts have a collective consciousness through time 
and space, and that each moment through time appears to them as one. One 
commented "There is no distance between us. No false veil of time or space 
may intervene".

It is also worth mentioning that there seems to be a sort of practical 
afterlife available for Vortigaunts, one once stated "What seems to you a 
sacrifice is merely, to us, an oscillation. We do not fear the interval of 
darkness." The statement implies that, whenever a vortigaunt dies, it 
passes into "the interval of darkness", from which it may be able to 
emerge anew, possibly in a new body or in an astral form.

While they have their own language, Vortigese, Vortigaunts are also able 
to speak in highly verbose English (and remark humorously on the etiquette 
of which language to use "We vocalize in your auditory language as a 
matter of courtesy. Unless we wish to say unflattering things about 
you."). They also tend to refer to some people by adding "the" before 
their name, such as "The Dresher" or "The James Dresher". Vortigaunts can 
communicate with one another telepathically through a life-force they call 
the Vortessence. They believe Vortessence is the fabric of the universe, 
made of vortal cords, of which everything is woven (and therefore 
everything is connected).

Vortigaunts are able to read and control this force for their electrical 
powers, nearly hive-mind telepathy and, likely, their ability to take 
power from objects. They are also able to use the Vortessence to heal 
wounds to an extent, and keep the dying from dying.

While Vortigaunts usually attack aggressively, they often become timid 
when injured, preferring to run away rather than risk further combat and 
possible death. They have two modes of attack: an energy attack in which 
they fire fairly powerful green lightning-like energy beams that require a 
vulnerable period of "charging-up" before being unleashed, and when close 
to opponents, they attack with their claws. Only objects with significant 
mass can resist being knocked back, such as the Strider (which appears to 
be fully immune to the beam) and Antlion Guards. It is also suggested that 
Vortigaunts can siphon an opponent's lifeforce with their energy beam 
attack, as they are heard saying phrases like "Give over your essence!" or 
"Empower us!" during some of their attacks.

Vortigaunts today wear slaver collars that block out their control of 
energy. They can sometimes be seen around cities doing manual labour for 
the Combine.
]];

ITEM:Register();